include(`domains.m4')
ce : conc* A -> conc' A -> type.
%mode ce +SP* -SP'.

- : ce topr topr.
- : ce (ax H) (ax H).
- : ce (andr SP1 SP2) (andr SP1' SP2')
     <- ce SP1 SP1'
     <- ce SP2 SP2'.
- : ce (andl1 SP1 H) (andl1 SP1' H)
     <- ({h} ce (SP1 h) (SP1' h)).
- : ce (andl2 SP1 H) (andl2 SP1' H)
     <- ({h} ce (SP1 h) (SP1' h)).
- : ce (orr1 SP) (orr1 SP')
     <- ce SP SP'.
- : ce (orr2 SP) (orr2 SP')
     <- ce SP SP'.
- : ce (orl SP1 SP2 H) (orl SP1' SP2' H)
     <- ({x} ce (SP1 x) (SP1' x))
     <- ({x} ce (SP2 x) (SP2' x)).
- : ce (impr SP1) (impr SP1')
     <- ({h} ce (SP1 h) (SP1' h)).
- : ce (impl SP1 SP2 H) (impl SP1' SP2' H)
     <- ce SP1 SP1'
     <- ({h1} ce (SP2 h1) (SP2' h1)).

- : ce data+/@eval/lam data+/@eval/lam.
- : ce data+/@eval/num data+/@eval/num.
- : ce (data+/@eval/app SP2 SP1) (data+/@eval/app SP2' SP1')
     <- ce SP2 SP2'
     <- ce SP1 SP1'.
- : ce (data+/@eval/case/z SP2 SP1) (data+/@eval/case/z SP2' SP1')
     <- ce SP2 SP2'
     <- ce SP1 SP1'.
- : ce (data+/@eval/case/s SP2 SP1) (data+/@eval/case/s SP2' SP1')
     <- ce SP2 SP2'
     <- ce SP1 SP1'.
- : ce (data+/@eval/l SP1 SP2 SP3 SP4 SP5 H)
     (data+/@eval/l SP1' SP2' SP3' SP4' SP5' H)
     <- ({e0}{q1}{q2} ce (SP1 e0 q1 q2) (SP1' e0 q1 q2))
     <- ({n}{q1}{q2} ce (SP2 n q1 q2) (SP2' n q1 q2))
     <- ({e1}{e2}{e0}{v}{dp2}{dp1}{dp2+}{dp1+}{q1}{q2}
           ce (SP3 e1 e2 e0 v dp2 dp1 dp2+ dp1+ q1 q2)
                    (SP3' e1 e2 e0 v dp2 dp1 dp2+ dp1+ q1 q2))
     <- ({e0}{e1}{e2}{v}{dp0}{dp1}{dp0+}{dp1+}{q1}{q2}
           ce (SP4 e1 e2 e0 v dp0 dp1 dp0+ dp1+ q1 q2)
                  (SP4' e1 e2 e0 v dp0 dp1 dp0+ dp1+ q1 q2))
     <- ({e0}{e1}{e2}{v}{n}{dp0}{dp1}{dp0+}{dp1+}{q1}{q2}
           ce (SP5 e1 e2 e0 v n dp0 dp1 dp0+ dp1+ q1 q2)
                  (SP5' e1 e2 e0 v n dp0 dp1 dp0+ dp1+ q1 q2)).

- : ce (cut SP1 SP2) SP
     <- ce SP1 SP1'
     <- ({h} ce (SP2 h) (SP2' h))
     <- msre-tot _ FP
     <- ca* FP SP1' SP2' SP.

- : ce (cut SP1' SP2') SP
     <- msre-tot _ FP
     <- ca* FP SP1' SP2' SP.

undivert(DIV_CUTELIM)
divert(-1)
undivert